Internationalization

6 Feb 202624 minutes to read

The Internationalization library provides support for formatting and parsing date and number objects using the official Unicode CLDR JSON data. The en-US locale is set as default culture and USD is set as default _currencyCode_ for all Syncfusion® JavaScript UI controls.

Loading culture data

The Syncfusion® CLDR data package contains JSON data files generated using the official Unicode CLDR JSON data. This helps avoid utilizing the existing cldr-data package, which has third-party library vulnerabilities. The loadCldr function is required to load the following CLDR data for cultures other than en-US.

Note: The Syncfusion® CLDR data package is published based on the releases of the Unicode CLDR JSON data. The package will be published within a week after the official Unicode CLDR JSON data is released.

Individual file path reference

Syncfusion® CLDR data can be loaded by referring to individual paths from the package as shown below:

File Name Path
ca-gregorian @syncfusion/ej2-cldr-data/main/en/ca-gregorian.json
timeZoneNames @syncfusion/ej2-cldr-data/main/en/timeZoneNames.json
numbers @syncfusion/ej2-cldr-data/main/en/numbers.json
currencies @syncfusion/ej2-cldr-data/main/en/currencies.json
numberingSystems @syncfusion/ej2-cldr-data/supplemental/numberingSystems.json

Single file path reference

Syncfusion® CLDR data can also be loaded by referring to a single path from the package as shown below:

File Name Path
ca-gregorian, timeZoneNames, numbers, currencies @syncfusion/ej2-cldr-data/main/en/all.json
numberingSystems @syncfusion/ej2-cldr-data/supplemental/numberingSystems.json

Note: For the en culture, dependency files are already included in the library.

Installing CLDR data

The Syncfusion® CLDR data is available as an npm package. It can be installed through the following command in your package.

npm install @syncfusion/ej2-cldr-data

Binding to i18n library

The i18n library uses the CLDR data to format and parse number and date/time values in a way that is appropriate for the specified culture. The loadCldr function takes two arguments, enNumberData and enTimeZoneData, which are the CLDR data for numbers and time zones, respectively, for the en culture.

import { loadCldr } from '@syncfusion/ej2-base';
import enNumberData from "@syncfusion/ej2-cldr-data/main/en/numbers.json";
import entimeZoneData from "@syncfusion/ej2-cldr-data/main/en/timeZoneNames.json";
loadcldr(enNumberData, entimeZoneData);

Changing global culture and currency code

To set the default culture and the currency code for all Syncfusion® JavaScript UI controls, use the setCulture method for setting the default locale and the setCurrencyCode method for setting the currency code.

import {setCulture, setCurrencyCode} from '@syncfusion/ej2-base';
setCulture('ar');
setCurrencyCode('QAR');

Note: If global culture is not set, then en-US is set as the default locale, and USD is set as the default currency code.

Manipulating numbers

Supported format string

Based on the NumberFormatOptions number formatting and parsing operations are processed. You need to specify some or all of the following properties mentioned below table.

No Properties Description
1 format Denotes the format to be set .Possible values are
1. N - denotes numeric type.
2. C - denotes currency type.
3. P - denotes percentage type.
E.g:
formatNumber( 1234344 ,{format:'N4'}).

Note: If no format is specified it takes numeric as default format type.
2 minimumFractionDigits Indicates the minimum number of fraction digits. Possible values are 0 to 20.
3 maximumFractionDigits Indicates the maximum number of fraction digits. Possible values are 0 to 20.
4 minimumSignificantDigits Indicates the minimum number of significant digits. Possible values are 1 to 21.
Note: If minimumSignificantDigits is given it is mandatory to give maximumSignificantDigits
5 maximumSignificantDigits Indicates the maximum number of significant digits. . Possible values are 1 to 21.
Note: If maximumSignificantDigits is given it is mandatory to give minimumSignificantDigits
6 useGrouping Indicates whether to enable the group separator or not . By default grouping value will be true.
7 minimumIntegerDigits Indicates the minimum number of the integer digits to be placed in the value. Possible values are 1 to 21.
8 currency Indicates the currency code which needs to considered for the currency formatting.

Note: The minimumIntegerDigits, minimumFractionDigits and maximumFractionDigits are categorized
as group one,
minimumSignificantDigits and maximumSignificantDigits are categorized as group two.
If group two properties are defined, then the group one properties will be ignored.

Custom number formatting and parsing

Custom number formatting and parsing can also be achieved by directly specifying the pattern in the format property of NumberFormatOptions. One or more of the custom format specifiers listed in the table below can be used to create custom number format.

Specifier Description Input Format Output
0 Replaces the zero with the corresponding digit if one is present. Otherwise, zero appears in the result string. instance.formatNumber(123,{format: ‘0000’ }) ‘0123’
# Replaces the “#” symbol with the corresponding digit if one is present; otherwise, no digit appears in the result string. instance.formatNumber(1234,{format: ‘####’ }) ‘1234’
. Denotes the number of digits allowed after the decimal points if it’s not specified then no need to specify decimal point values. instance.formatNumber(546321,{format: ‘###0.##0#’ }) ‘546321.000’
% Percent specifier denotes the percentage type format. instance.formatNumber(1,{format: ‘0000 %’ }) ‘0100 %’
$ Denotes the currency type format based on the global currency code specified. instance.formatNumber(13,{format: ‘$ ###.00’ }); ‘$ 13.00’
; Denotes separate formats for positive, negative and zero values. instance.formatNumber(-120,{format: ‘###.##;(###.00);-0’}); ‘(120.00)’
‘String’ (single Quotes) Denotes the characters enclosed within single Quote(‘) to be replaced in the resultant string. instance.formatNumber(-123.44,{format: “####.## ‘@’”}) ‘123.44 @’

Note: If a custom format pattern is specified, other NumberFormatOptions properties will not be considered.

Number Parsing

getNumberParser

The getNumberParser method, which will return a function that parses a given string based on the NumberFormatOptions specified.

var intl = new ej.base.Internationalization();
var nParser =  intl.getNumberParser({ format:'P2' , useGrouping: false});
var val = nParser('123567.45%');
document.querySelector('.result').innerHTML = val + '';
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Form Validator</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
       <div>FormattedValue:<span class="format text">123567.45%</span></div>
       <div>ParsedOutput:<span class="result text"> </span></div>
    </div>




<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

parseNumber

The parseNumber method, which takes two arguments, the string value and NumberFormatOptions and returns the numeric value.

var intl = new ej.base.Internationalization();
var val = intl.parseNumber('$01,234,545.650', { format: 'C3', currency: 'USD', minimumIntegerDigits: 8 });
document.querySelector('.result').innerHTML = val + '';
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Form Validator</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
       <div>FormattedValue:<span class="format text">$01,234,545.650</span></div>
       <div>ParsedOutput:<span class="result text"> </span></div>
    </div>




<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Number formatting

getNumberFormat

The getNumberFormat method will return a function that formats a given number based on the NumberFormatOptions specified.

var intl = new ej.base.Internationalization();
var nFormatter = intl.getNumberFormat({ skeleton: 'C3', currency: 'USD',minimumIntegerDigits:8});
var formattedValue = nFormatter(1234545.65)
document.querySelector('.result').innerHTML = formattedValue;
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Form Validator</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
       <div>Value:<span class="format text">1234545.65</span></div>
       <div>Formatted Value:<span class="result text"> </span></div>
    </div>




<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

formatNumber

The formatNumber method, which takes two arguments, a numeric value and NumberFormatOptions and returns the formatted string.

var intl = new ej.base.Internationalization();
var formattedString = intl.formatNumber(12345.65, { format:'C5' , useGrouping: false,
 minimumSignificantDigits:1, maximumSignificantDigits:3 });
document.querySelector('.result').innerHTML = formattedString;
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Form Validator</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
       <div>Value:<span class="format text">1234545.65</span></div>
       <div>Formatted Value:<span class="result text"> </span></div>
    </div>




<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Manipulating dateTime

Supported format string

Date formatting and parsing operations are performed based on the DateFormatOptions. You need to specify some or all of the following properties mentioned in the table below.

Options Descriptions
Type It specifies the type of format to be used supported types .
1. date
2. dateTime
3. time
Based on the type specified the supported skeletons are given below.
1. short
2. medium,
3. long
4. full
E.g: formatDate(new Date(), {type: 'date', skeleton:medium})
Note: If no type is specified then date type is set by default.
skeleton Specifies the format in which the dateTime format will process

Date type skeletons

skeleton Option input Format Output
short {type: 'date', skeleton:'short'}) 11/4/16
medium {type: 'date', skeleton:'medium'}) Nov 4, 2016
long {type: 'date', skeleton:'long'} November 4, 2016
full {type: 'date', skeleton:full}) Friday, November 4, 2016

Time type skeletons

skeleton Option input Format Output
short {type: 'time', skeleton:'short'} 1:03 PM
medium {type: 'time', skeleton:'medium'} 1:03:04 PM
Long {type: 'time', skeleton:'long'}) 1:03:04 PM GMT+5
full {type: 'time', skeleton:'full'}) 1:03:04 PM GMT+05:30

DateTime type skeletons

Skeleton Option input Format Output
short {type: 'dateTime', skeleton:'short'} 11/4/16, 1:03 PM
medium {type: 'dateTime, skeleton:'medium'} Nov 4, 2016, 1:03:04 PM
Long {type: 'dateTime', skeleton:'long'}) November 4, 2016 at 1:03:04 PM GMT+5
full {type: 'dateTime', skeleton:'full'}) Friday, November 4, 2016 at 1:03:04 PM GMT+05:30

Additional skeletons

Apart from the standard date type formats additional format are supported by using the additional skeletons given in below table.

skeleton Option input Format Output
d {skeleton:'d'} 7
E {skeleton:'E'} Mon
Ed {skeleton:'Ed'} 7 Mon
Ehm {skeleton:'Ehm'}) Mon 12:43 AM
EHm {skeleton:'EHm;}); Mon 12:43
Ehms {skeleton:'Ehms' } Mon 2:45:23 PM
EHms {skeleton:'EHms'}) Mon 12:45:45
Gy {skeleton:'Gy' } 2016 AD
GyMMM {skeleton:'GyMMM'} : Nov 2016 AD
GyMMMd {skeleton:'GyMMMd'} Nov 7, 2016 AD
GyMMMEd {skeleton:'GyMMMEd'} Mon, Nov 7, 2016 AD
h {skeleton:'h'} 12 PM
H {skeleton:'H'} 12
hm {skeleton:'hm'} 12:59 PM
Hm {skeleton:'Hm'} 12:59
hms {skeleton:'hms'} 12:59:13 PM
Hms {skeleton:'Hms'} 12:59:13
M {skeleton:'M'} 11
Md {skeleton:'Md'} 11/7
MEd {skeleton:'hms'} Mon, 11/7
MMM {skeleton:'MMM'} Nov
MMMEd {skeleton:'MMMEd'} Mon, Nov 7
MMMd {skeleton:'MMMEd'} Nov 7
ms {skeleton:'ms'} 59:13
y {skeleton:'y' } 2016
yM {skeleton:'yM' } 11/2016
yMd {skeleton:'yMd' } 11/7/2016
yMEd {skeleton:'yMEd' } Mon, 11/7/2016
yMMM {skeleton:'yMMM' } Nov 2016
yMMMd {skeleton:'yMMMd'} Nov 7, 2016
yMMMEd {skeleton:'yMMMEd'} Mon, Nov 7, 2016
yMMM {skeleton:'yMMM'} Nov 2016

Note: Culture specific format skeletons are also supported.

Custom formats

To use the custom date and time formats we need to specify the date/time pattern directly in the format property.
Custom format string must contain one or more of the following standard date/time symbols

Symbols Description
G Denotes the era in the date
y Denotes the year.
M / L Denotes month.
E / c Denotes the day of week.
d Denotes the day of month.
h / H Denotes the hour. h for 12 hour and H for 24 hours format.
m Denotes minutes.
s Denotes seconds.
a Denotes the am/pm designator it will only be displayed if hour is specified in the h format.
z Denotes the time zone.
’ (single quotes) To display words in the formatted date you can specify the words with in the single quotes

Custom format example

import { Internationalization } from '@syncfusion/ej2-base';

let intl: Internationalization = new Internationalization();
let formattedString: string =  intl.formatDate(new Date('1/12/2014 10:20:33'), { format: '\'year:\'y' \'month:\' MM' });
//Output: "year:2014 month:01"

Note: If the format property is given as an option, other properties are not considered.

Date Parsing

getDateParser

The getDateParser method will return a function that parses a given string based on the DateFormatOptions specified.

var intl = new ej.base.Internationalization();
var dParser = intl.getDateParser({skeleton: 'full', type: 'dateTime'});
var val = dParser('Friday, November 4, 2016 at 1:03:04 PM GMT+05:30');
document.querySelector('.result').innerHTML = val.toString();
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Form Validator</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
 <div>Fromatted value:<span class="format text">Friday, November 4, 2016 at 1:03:04 PM GMT+05:30</span></div>
       <div>parsed Value:<span class="result text"> </span></div>
  
    </div>




<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

parseDate

The date object is returned by the parseDate method, which takes two arguments, a string value and DateFormatOptions.

var intl = new ej.base.Internationalization();
var val =  intl.parseDate('11/2016',{skeleton: 'yM'});

document.querySelector('.result').innerHTML = val.toString();
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Form Validator</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
 <div>Fromatted value:<span class="format text">11/2016</span></div>
       <div>parsed Value:<span class="result text"> </span></div>
  
    </div>




<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Date Formatting

getDateFormat

The getDateFormat method, which will return a function that formats a given date object based on the DateFormatOptions specified.

var intl = new ej.base.Internationalization();
var dFormatter = intl.getDateFormat({ skeleton: 'full', type: 'dateTime' });
var formattedString = dFormatter(new Date('1/12/2014 10:20:33'));
document.querySelector('.result').innerHTML = formattedString;
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Form Validator</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
 <div>DateValue:<span class="format text">new Date('1/12/2014 10:20:33')</span></div>
       <div>Formatted Value:<span class="result text"> </span></div>
  
    </div>




<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

formatDate

The formatDate method, which takes two arguments, the date object and DateFormatOptions, returns the formatted string.

var intl = new ej.base.Internationalization();
var date = new Date();
var formattedString =  intl.formatDate(new Date('1/12/2014 10:20:33'), { skeleton: 'GyMMM' });
document.querySelector('.result').innerHTML = formattedString;
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Form Validator</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
 <div>DateValue:<span class="format text">new Date('1/12/2014 10:20:33')</span></div>
       <div>Formatted Value:<span class="result text"> </span></div>
  
    </div>




<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

HelpBot Assistant

How can I help you?

Internationalization

2 Feb 202624 minutes to read

The Syncfusion® Internationalization library provides powerful tools for formatting and parsing date and number objects, using the official Unicode CLDR JSON data. By default, the en-US locale and USD currency code are preset for all Syncfusion® Angular UI Components.

Loading CLDR-JSON Data

Syncfusion® CLDR data package contains JSON data files generated from the official Unicode CLDR JSON data. This package avoids third-party library vulnerabilities present in the older cldr-data package. To use cultures other than en-US, load the appropriate CLDR data using the loadCldr function.

NOTE

Syncfusion® CLDR data package is published within a week after each official Unicode CLDR JSON data release.

Individual file path reference

Load Syncfusion® CLDR data by referring to individual file paths from the package:

File Name Path
ca-gregorian @syncfusion/ej2-cldr-data/main/en/ca-gregorian.json
timeZoneNames @syncfusion/ej2-cldr-data/main/en/timeZoneNames.json
numbers @syncfusion/ej2-cldr-data/main/en/numbers.json
currencies @syncfusion/ej2-cldr-data/main/en/currencies.json
numberingSystems @syncfusion/ej2-cldr-data/supplemental/numberingSystems.json

Single file path reference

Alternatively, load Syncfusion® CLDR data using a single consolidated file:

File Name Path
ca-gregorian, timeZoneNames, numbers, currencies @syncfusion/ej2-cldr-data/main/en/all.json
numberingSystems @syncfusion/ej2-cldr-data/supplemental/numberingSystems.json

Note: For en, dependency files are already loaded in the library.

Installing CLDR data

Install the Syncfusion® CLDR data package through npm:

npm install @syncfusion/ej2-cldr-data

Binding to i18n library

The i18n library uses CLDR data to format and parse numbers and date/time values for the en culture. Load the data using the loadCldr function:

import { loadCldr } from '@syncfusion/ej2-base';
import enNumberData from "@syncfusion/ej2-cldr-data/main/en/numbers.json";
import enTimeZoneData from "@syncfusion/ej2-cldr-data/main/en/timeZoneNames.json";

loadCldr(enNumberData, enTimeZoneData);

Changing Global Culture and Currency Code

Update the default culture and currency code across all Syncfusion® Angular UI Components using the setCulture and setCurrencyCode methods:

import { setCulture, setCurrencyCode } from '@syncfusion/ej2-base';

setCulture('ar');
setCurrencyCode('QAR');

Note: If global culture is not set, en-US is the default locale and USD is the default currency code.

Manipulating Numbers

Supported format string

Number formatting and parsing align with NumberFormatOptions. Specify relevant properties as shown:

No Properties Description
1 format Specifies the format type. Possible values are:
1. N – numeric type
2. C – currency type
3. P – percentage type

Example: formatNumber(1234344, {format: 'N4'})

Note: If no format is specified, numeric type is used by default.
2 minimumFractionDigits Specifies the minimum number of fraction digits. Possible values are 0 to 20.
3 maximumFractionDigits Specifies the maximum number of fraction digits. Possible values are 0 to 20.
4 minimumSignificantDigits Specifies the minimum number of significant digits. Possible values are 1 to 21.

Note: When minimumSignificantDigits is set, maximumSignificantDigits is mandatory.
5 maximumSignificantDigits Specifies the maximum number of significant digits. Possible values are 1 to 21.

Note: When maximumSignificantDigits is set, minimumSignificantDigits is mandatory.
6 useGrouping Enables or disables the group separator. Default value is true.
7 minimumIntegerDigits Specifies the minimum number of integer digits. Possible values are 1 to 21.
8 currency Specifies the currency code for currency formatting.

Note: Properties minimumIntegerDigits, minimumFractionDigits, and maximumFractionDigits form Group One. Properties minimumSignificantDigits and maximumSignificantDigits form Group Two. If Group Two properties are defined, Group One properties are ignored.

Custom number formatting and parsing

Create custom number formats by specifying a pattern directly in the format property of NumberFormatOptions. Use one or more of the custom format specifiers below:

Specifier Description Input Output
0 Displays the corresponding digit or zero if absent. formatNumber(123, {format: '0000'}) ‘0123’
# Displays the corresponding digit; omits if absent. formatNumber(1234, {format: '####'}) ‘1234’
. Denotes decimal point position. formatNumber(546321, {format: '###0.##0#'}) ‘546321.000’
% Applies percentage format. formatNumber(1, {format: '0000 %'}) ‘0100 %’
$ Applies currency format based on global currency code. formatNumber(13, {format: '$ ###.00'}) ’$ 13.00’
; Specifies separate formats for positive, negative, and zero values. formatNumber(-120, {format: '###.##;(###.00);-0'}) ‘(120.00)’
‘String’ Displays literal text enclosed in single quotes. formatNumber(-123.44, {format: "####.## '@'"}) ‘123.44 @’

Note: When a custom format pattern is specified, other NumberFormatOptions properties are not applied.

Number Parsing

getNumberParser

The getNumberParser method returns a function that parses strings based on the specified NumberFormatOptions.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'




import { Component } from '@angular/core';
import { Internationalization } from  '@syncfusion/ej2-base';

@Component({
    
standalone: true,
    selector: 'app-root',
    template:` <div id='container'>
    <div>FormattedValue:<span class='format text'>123567.45%</span></div>
    <div>ParsedOutput:<span class='result text'> </span></div>
    </div>`
})

export class AppComponent {
    ngAfterViewInit() {
        let intl: Internationalization = new Internationalization();
        let nParser: Function =  intl.getNumberParser({ format:'P2' , useGrouping: false});
        let val: number = nParser('123567.45%');
        (document.querySelector('.result') as Element).innerHTML = val + '';
        }
        }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

parseNumber

The parseNumber method parses a string value based on NumberFormatOptions and returns the numeric value.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'




import { Component } from '@angular/core';
import { Internationalization } from  '@syncfusion/ej2-base';

@Component({

standalone: true,
    selector: 'app-root',
    template:` <div id='container'>
    <div>FormattedValue:<span class='format text'>$01,234,545.650</span></div>
    <div>ParsedOutput:<span class='result text'> </span></div>
    </div>`
})

export class AppComponent {
    ngAfterViewInit() {
        let intl: Internationalization = new Internationalization();
        let val: number = intl.parseNumber('$01,234,545.650', { format: 'C3', currency: 'USD', minimumIntegerDigits: 8 });
        (document.querySelector('.result') as any).innerHTML = val + '';
        }
        }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Number formatting

getNumberFormat

The getNumberFormat method returns a function that formats numbers based on the specified NumberFormatOptions.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'




import { Component } from '@angular/core';
import { Internationalization } from  '@syncfusion/ej2-base';

@Component({
standalone: true,
    selector: 'app-root',
    template:` <div id='container'>
    <div>Value:<span class='format text'>1234545.65</span></div>
    <div>Formatted Value:<span class='result text'> </span></div>
    </div> `
})

export class AppComponent {
    ngAfterViewInit() {
        let intl: Internationalization = new Internationalization();
        let nFormatter: Function = intl.getNumberFormat({ skeleton: 'C3', currency: 'USD',minimumIntegerDigits:8});
        let formattedValue: string = nFormatter(1234545.65);
        (document.querySelector('.result') as Element).innerHTML = formattedValue as string;
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

formatNumber

The formatNumber method formats a numeric value based on NumberFormatOptions and returns the formatted string.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'




import { Component } from '@angular/core';
import { Internationalization } from  '@syncfusion/ej2-base';

@Component({
standalone: true,
    selector: 'app-root',
    template:` <div id='container'>
    <div>Value:<span class='format text'>1234545.65</span></div>
    <div>Formatted Value:<span class='result text'> </span></div>
    </div> `
    })

export class AppComponent {
    ngAfterViewInit() {
        let intl: Internationalization = new Internationalization();
        let formattedString: string = intl.formatNumber(12345.65,{ format:'C5' ,
        useGrouping: false,minimumSignificantDigits:1, maximumSignificantDigits:3 });
        (document.querySelector('.result') as Element).innerHTML = formattedString;
        }
        }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Manipulating DateTime

Supported format string

Date formatting and parsing operations use the DateFormatOptions. Specify some or all of the properties shown below:

Options Description
Type Specifies the format type. Supported types:
1. date
2. dateTime
3. time

Based on the type, supported skeletons are: short, medium, long, full

Example: formatDate(new Date(), {type: 'date', skeleton: 'medium'})

Note: If type is not specified, date is used by default.
skeleton Specifies the format pattern for date/time output.

Date type skeletons

skeleton Option input Format Output
short {type: ‘date’, skeleton: ‘short’} 11/4/16
medium {type: ‘date’, skeleton: ‘medium’} Nov 4, 2016
long {type: ‘date’, skeleton: ‘long’} November 4, 2016
full {type: ‘date’, skeleton: ‘full’} Friday, November 4, 2016

Time type skeletons

skeleton Option input Format Output
short {type: ‘time’, skeleton: ‘short’} 1:03 PM
medium {type: ‘time’, skeleton: ‘medium’} 1:03:04 PM
long {type: ‘time’, skeleton: ‘long’} 1:03:04 PM GMT+5
full {type: ‘time’, skeleton: ‘full’} 1:03:04 PM GMT+05:30

DateTime type skeletons

skeleton Option input Format Output
short {type: ‘dateTime’, skeleton: ‘short’} 11/4/16, 1:03 PM
medium {type: ‘dateTime’, skeleton: ‘medium’} Nov 4, 2016, 1:03:04 PM
long {type: ‘dateTime’, skeleton: ‘long’} November 4, 2016 at 1:03:04 PM GMT+5
full {type: ‘dateTime’, skeleton: ‘full’} Friday, November 4, 2016 at 1:03:04 PM GMT+05:30

Additional skeletons

Beyond standard date formats, use these additional skeletons for specialized formatting:

skeleton Option input Format Output
d {skeleton: ‘d’} 7
E {skeleton: ‘E’} Mon
Ed {skeleton: ‘Ed’} 7 Mon
Ehm {skeleton: ‘Ehm’} Mon 12:43 AM
EHm {skeleton: ‘EHm’} Mon 12:43
Ehms {skeleton: ‘Ehms’} Mon 2:45:23 PM
EHms {skeleton: ‘EHms’} Mon 12:45:45
Gy {skeleton: ‘Gy’} 2016 AD
GyMMM {skeleton: ‘GyMMM’} Nov 2016 AD
GyMMMd {skeleton: ‘GyMMMd’} Nov 7, 2016 AD
GyMMMEd {skeleton: ‘GyMMMEd’} Mon, Nov 7, 2016 AD
h {skeleton: ‘h’} 12 PM
H {skeleton: ‘H’} 12
hm {skeleton: ‘hm’} 12:59 PM
Hm {skeleton: ‘Hm’} 12:59
hms {skeleton: ‘hms’} 12:59:13 PM
Hms {skeleton: ‘Hms’} 12:59:13
M {skeleton: ‘M’} 11
Md {skeleton: ‘Md’} 11/7
MEd {skeleton: ‘MEd’} Mon, 11/7
MMM {skeleton: ‘MMM’} Nov
MMMEd {skeleton: ‘MMMEd’} Mon, Nov 7
MMMd {skeleton: ‘MMMd’} Nov 7
ms {skeleton: ‘ms’} 59:13
y {skeleton: ‘y’} 2016
yM {skeleton: ‘yM’} 11/2016
yMd {skeleton: ‘yMd’} 11/7/2016
yMEd {skeleton: ‘yMEd’} Mon, 11/7/2016
yMMM {skeleton: ‘yMMM’} Nov 2016
yMMMd {skeleton: ‘yMMMd’} Nov 7, 2016
yMMMEd {skeleton: ‘yMMMEd’} Mon, Nov 7, 2016

Note: Culture-specific format skeletons are also supported.

Custom formats

Create custom date and time formats by specifying a pattern directly in the format property. Use one or more of the standard date/time symbols below:

Symbol Description
G Specifies the era in the date.
y Specifies the year.
M / L Specifies the month.
E / c Specifies the day of the week.
d Specifies the day of the month.
h / H Specifies the hour. Use h for 12-hour format or H for 24-hour format.
m Specifies the minutes.
s Specifies the seconds.
f Specifies the milliseconds.
a Specifies the AM/PM designator (displayed only when hour is in h format).
z Specifies the time zone.
’ (single quotes) Displays literal text by enclosing it in single quotes.

Custom format example

import { Component } from '@angular/core';
import { Internationalization } from '@syncfusion/ej2-base';

@Component({
    selector: 'app-root',
    templateUrl: 'default.html'
})
export class AppComponent {
    ngAfterViewInit() {
        let intl: Internationalization = new Internationalization();
        let formattedString: string = intl.formatDate(
            new Date('1/12/2014 10:20:33'),
            { format: "'year:' y 'month:' MM" }
        );
        // Output: "year: 2014 month: 01"
    }
}

Note: When the format property is specified, other DateFormatOptions properties are not applied.

Date Parsing

getDateParser

The getDateParser method returns a function for parsing strings based on the specified DateFormatOptions.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'




import { Component } from '@angular/core';
import { Internationalization } from  '@syncfusion/ej2-base';

@Component({
standalone: true,
    selector: 'app-root',
    template:` <div id='container'>
    <div>Fromatted value:<span class='format text'>Friday, November 4, 2016 at 1:03:04 PM GMT+05:30</span></div>
    <div>parsed Value:<span class='result text'> </span></div>
    </div> `
})

export class AppComponent {
    ngAfterViewInit() {
        let intl: Internationalization = new Internationalization();
        let dParser: Function = intl.getDateParser({skeleton: 'full', type: 'dateTime'});
        let val: Date = dParser('Friday, November 4, 2016 at 1:03:04 PM GMT+05:30');
        (document.querySelector('.result') as Element).innerHTML = val.toString();
        }
        }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

parseDate

The parseDate method parses a string value based on DateFormatOptions and returns the date object.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'




import { Component } from '@angular/core';
import { Internationalization } from  '@syncfusion/ej2-base';

@Component({
standalone: true,
    selector: 'app-root',
    template:` <div id='container'>
    <div>Fromatted value:<span class='format text'>11/2016</span></div>
    <div>parsed Value:<span class='result text'> </span></div>
    </div> `
})

export class AppComponent {
    ngAfterViewInit() {
        let intl:Internationalization = new Internationalization();
        let val: number | any =  intl.parseDate('11/2016',{skeleton: 'yM'});
        (document.querySelector('.result') as Element).innerHTML = val.toString();
        }
        }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Date Formatting

getDateFormat

The getDateFormat method returns a function that formats date objects based on the specified DateFormatOptions.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'




import { Component } from '@angular/core';
import { Internationalization } from  '@syncfusion/ej2-base';

@Component({
standalone: true,
    selector: 'app-root',
    template:` <div id='container'>
    <div>DateValue:<span class='format text'>new Date('1/12/2014 10:20:33')</span></div>
    <div>Formatted Value:<span class='result text'> </span></div>
    <div> `
})

export class AppComponent {
    ngAfterViewInit() {
        let intl: Internationalization = new Internationalization();
        let dFormatter: Function = intl.getDateFormat({ skeleton: 'full', type: 'dateTime' });
        let formattedString: string = dFormatter(new Date('1/12/2014 10:20:33'));
        (document.querySelector('.result') as Element).innerHTML = formattedString;
        }
        }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

formatDate

The formatDate method formats a date object based on DateFormatOptions and returns the formatted string.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'


 

import { Component } from '@angular/core';
import { Internationalization } from  '@syncfusion/ej2-base';

@Component({

standalone: true,
    selector: 'app-root',
    template:` <div id='container'>
    <div>DateValue:<span class='format text'>new Date('1/12/2014 10:20:33')</span></div>
    <div>Formatted Value:<span class='result text'> </span></div>
    <div> `
})

export class AppComponent {
    ngAfterViewInit() {
        let intl: Internationalization = new Internationalization();
        let date: Date = new Date();
        let formattedString: string =  intl.formatDate(new Date('1/12/2014 10:20:33'), { skeleton: 'GyMMM' });
        (document.querySelector('.result') as Element).innerHTML = formattedString;
        }
        }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

HelpBot Assistant

How can I help you?

Internationalization

3 Feb 202624 minutes to read

The Internationalization library provides support for formatting and parsing date and number objects using the official Unicode CLDR JSON data. The en-US locale is set as the default culture and USD is set as the default _currencyCode_ for all Syncfusion® Vue UI Components.

Loading culture data

The Syncfusion® CLDR data package contains JSON files generated from the official Unicode CLDR JSON data. This helps avoid depending on the third-party cldr-data package, which may have vulnerabilities. The loadCldr function is required to load CLDR data for cultures other than en-US.

NOTE

Syncfusion® CLDR data package is published based on the releases of the Unicode CLDR JSON data. The package will be published within a week after the official Unicode CLDR JSON data is released.

Individual file path reference

Syncfusion® CLDR data can be loaded by referring to individual paths from the package below, such as:

File Name Path
ca-gregorian @syncfusion/ej2-cldr-data/main/en/ca-gregorian.json
timeZoneNames @syncfusion/ej2-cldr-data/main/en/timeZoneNames.json
numbers @syncfusion/ej2-cldr-data/main/en/numbers.json
currencies @syncfusion/ej2-cldr-data/main/en/currencies.json
numberingSystems @syncfusion/ej2-cldr-data/supplemental/numberingSystems.json

Single file path reference

Syncfusion® CLDR data can also be loaded by referring to a single path from the package below, such as:

File Name Path
ca-gregorian, timeZoneNames, numbers, currencies @syncfusion/ej2-cldr-data/main/en/all.json
numberingSystems @syncfusion/ej2-cldr-data/supplemental/numberingSystems.json

Note: For en, dependency files are already loaded in the library.

Installing CLDR data

Syncfusion® CLDR data is available as npm package. So, we can install it through below command to our package.

npm install @syncfusion/ej2-cldr-data

Binding to i18n library

The i18n library uses CLDR data to format and parse numbers and date/time values for the specified culture. The loadCldr function takes CLDR JSON data as arguments.

import { loadCldr } from '@syncfusion/ej2-base';
import enNumberData from "@syncfusion/ej2-cldr-data/main/en/numbers.json";
import entimeZoneData from "@syncfusion/ej2-cldr-data/main/en/timeZoneNames.json";

loadcldr(enNumberData, entimeZoneData);

Changing Global Culture and Currency Code

To set the default culture and currency code for all Syncfusion Vue UI Components, use setCulture to set the default locale and setCurrencyCode to set the currency code.

import {setCulture, setCurrencyCode} from '@syncfusion/ej2-base';
setCulture('ar');
setCurrencyCode('QAR');

Note: If no global culture is set, en-US is used as the default locale and USD is used as the default currency code.

Manipulating numbers

Supported format string

Based on the NumberFormatOptions number formatting and parsing operations are processed. You need to specify some or all of the following properties mentioned below table.

No Properties Description
1 format Denotes the format to be set .Possible values are
1. N - denotes numeric type.
2. C - denotes currency type.
3. P - denotes percentage type.
E.g:
formatNumber( 1234344 ,{format:'N4'}).

Note: If no format is specified it takes numeric as default format type.
2 minimumFractionDigits Indicates the minimum number of fraction digits . Possible values are 0 to 20.
3 maximumFractionDigits Indicates the maximum number of fraction digits. Possible values are 0 to 20.
4 minimumSignificantDigits Indicates he minimum number of significant digits. Possible values are 1 to 21.
Note: If minimumSignificantDigits is given it is mandatory to give maximumSignificantDigits
5 maximumSignificantDigits Indicates he maximum number of significant digits. . Possible values are 1 to 21.
Note: If maximumSignificantDigits is given it is mandatory to give minimumSignificantDigits
6 useGrouping Indicates whether to enable the group separator or not . By default grouping value will be true.
7 minimumIntegerDigits Indicates the minimum number of the integer digits to be placed in the value. Possible values are 1 to 21.
8 currency Indicates the currency code which needs to considered for the currency formatting.

Note: The minimumIntegerDigits, minimumFractionDigits and maximumFractionDigits are categorized
as group one,
minimumSignificantDigits and maximumSignificantDigits are categorized as group two.
If group two properties are defined, then the group one properties will be ignored.

Custom number formatting and parsing

Custom number formatting and parsing can also be achieved by directly specifying the pattern in the format property of NumberFormatOptions. One or more of the custom format specifiers listed in the table below can be used to create custom number format.

Specifier Description Input Format Output
0 Replaces the zero with the corresponding digit if one is present. Otherwise, zero appears in the result string. instance.formatNumber(123,{format: ‘0000’ }) ‘0123’
# Replaces the “#” symbol with the corresponding digit if one is present; otherwise, no digit appears in the result string. instance.formatNumber(1234,{format: ‘####’ }) ‘1234’
. Denotes the number of digits allowed after the decimal points if it’s not specified then no need to specify decimal point values. instance.formatNumber(546321,{format: ‘###0.##0#’ }) ‘546321.000’
% Percent specifier denotes the percentage type format. instance.formatNumber(1,{format: ‘0000 %’ }) ‘0100 %’
$ Denotes the currency type format based on the global currency code specified. instance.formatNumber(13,{format: ‘$ ###.00’ }); ‘$ 13.00’
; Denotes separate formats for positive, negative and zero values. instance.formatNumber(-120,{format: ‘###.##;(###.00);-0’}); ‘(120.00)’
‘String’ (single Quotes) Denotes the characters enclosed within single Quote(‘) to be replaced in the resultant string. instance.formatNumber(-123.44,{format: “####.## ‘@’”}) ‘123.44 @’

Note: If a custom format pattern is specified, other NumberFormatOptions properties will not be considered.

Number Parsing

getNumberParser

The getNumberParser method returns a function that parses a string according to specified NumberFormatOptions.

<template>
    <div class="result" ref="result"></div>
</template>
    
<script setup>
import { Internationalization } from '@syncfusion/ej2-base';
import { onMounted, ref } from 'vue';

const result = ref(null);

onMounted(() => {
    var intl = new Internationalization();
    var nParser = intl.getNumberParser({ format: 'P2', useGrouping: false });
    var val = nParser('123567.45%');
    result.value.innerHTML = val + '';
})
</script>
<template>
<div class="result"></div>
</template>
<script>

import Vue from 'vue';
import { Internationalization } from '@syncfusion/ej2-base';
export default {
mounted:function(){
var intl  = new Internationalization();
var nParser  =  intl.getNumberParser({ format:'P2' , useGrouping: false});
var val  = nParser('123567.45%');
document.querySelector('.result').innerHTML = val + '';
}
}
</script>
<style>
</style>

parseNumber

The parseNumber method, which takes two arguments, the string value and NumberFormatOptions and returns the numeric value.

<template>
  <div class="result" ref="result"></div>
</template>
  
<script setup>
import { Internationalization } from '@syncfusion/ej2-base';
import { onMounted, ref } from 'vue';

const result = ref(null);

onMounted(() => {
  var intl = new Internationalization();
  var val = intl.parseNumber('$01,234,545.650', { format: 'C3', currency: 'USD', minimumIntegerDigits: 8 });
  result.value.innerHTML = val + '';
})
</script>
<template>
  <div class="result"></div>
</template>
<script>
  
import Vue from 'vue';
import { Internationalization } from '@syncfusion/ej2-base';
export default {
  mounted:function(){
  var intl  = new Internationalization();
  var val  = intl.parseNumber('$01,234,545.650', { format: 'C3', currency: 'USD', minimumIntegerDigits: 8 });
  document.querySelector('.result').innerHTML = val + '';
}
}
</script>
<style>
</style>

Number formatting

getNumberFormat

The getNumberFormat method returns a function that formats a number according to specified NumberFormatOptions.

<template>
  <div class="result" ref="result"></div>
</template>
    
<script setup>
import { Internationalization } from '@syncfusion/ej2-base';
import { onMounted, ref } from 'vue';

const result = ref(null);
onMounted(() => {
  var intl = new Internationalization();
  var nFormatter = intl.getNumberFormat({ skeleton: 'C3', currency: 'USD', minimumIntegerDigits: 8 });
  var formattedValue = nFormatter(1234545.65)
  result.value.innerHTML = formattedValue;
})
</script>
<template>
  <div class="result"></div>
</template>
<script>
import { Internationalization } from '@syncfusion/ej2-base';
export default {
  mounted:function(){
var  intl = new Internationalization();
var nFormatter = intl.getNumberFormat({ skeleton: 'C3', currency: 'USD',minimumIntegerDigits:8});
var formattedValue  = nFormatter(1234545.65)
document.querySelector('.result').innerHTML = formattedValue;
  }
}
</script>
<style>
</style>

formatNumber

The formatNumber method, which takes two arguments, a numeric value and NumberFormatOptions and returns the formatted string.

<template>
  <div class="result" ref="result"></div>
</template>
  
<script setup>
import { Internationalization } from '@syncfusion/ej2-base';
import { onMounted, ref } from 'vue';

const result = ref(null);
onMounted(() => {
  var intl = new Internationalization();
  var formattedString = intl.formatNumber(12345.65, {
    format: 'C5', useGrouping: false,
    minimumSignificantDigits: 1, maximumSignificantDigits: 3
  });
  result.value.innerHTML = formattedString;
})
</script>
<template>
  <div class="result"> </div>
</template>
<script>
import Vue from 'vue';
import { Internationalization } from '@syncfusion/ej2-base';
export default {
  mounted: function(){
var  intl = new Internationalization();
var formattedString  = intl.formatNumber(12345.65, { format:'C5' , useGrouping: false,
minimumSignificantDigits:1, maximumSignificantDigits:3 });
document.querySelector('.result').innerHTML = formattedString;
  }
}
</script>
<style>
</style>

Manipulating DateTime

Supported format string

Date formatting and parsing operations are performed based on the DateFormatOptions. You need to specify some or all of the following properties mentioned in the table below.

Options Descriptions
Type It specifies the type of format to be used supported types .
1. date
2. dateTime
3. time
Based on the type specified the supported skeletons are given below.
1. short
2. medium,
3. long
4. full
E.g: formatDate(new Date(), {type: 'date', skeleton:medium})
Note: If no type is specified then date type is set by default.
skeleton Specifies the format in which the dateTime format will process

Date type skeletons

skeleton Option input Format Output
short {type: 'date', skeleton:'short'}) 11/4/16
medium {type: 'date', skeleton:'medium'}) Nov 4, 2016
long {type: 'date', skeleton:'long'} November 4, 2016
full {type: 'date', skeleton:full}) Friday, November 4, 2016

Time type skeletons

skeleton Option input Format Output
short {type: 'time', skeleton:'short'} 1:03 PM
medium {type: 'time', skeleton:'medium'} 1:03:04 PM
Long {type: 'time', skeleton:'long'}) 1:03:04 PM GMT+5
full {type: 'time', skeleton:'full'}) 1:03:04 PM GMT+05:30

DateTime type skeletons

Skeleton Option input Format Output
short {type: 'dateTime', skeleton:'short'} 11/4/16, 1:03 PM
medium {type: 'dateTime, skeleton:'medium'} Nov 4, 2016, 1:03:04 PM
Long {type: 'dateTime', skeleton:'long'}) November 4, 2016 at 1:03:04 PM GMT+5
full {type: 'dateTime', skeleton:'full'}) Friday, November 4, 2016 at 1:03:04 PM GMT+05:30

Additional skeletons

Apart from the standard date type formats, additional formats are supported by using the additional skeletons given in the below table.

skeleton Option input Format Output
d {skeleton:'d'} 7
E {skeleton:'E'} Mon
Ed {skeleton:'Ed'} 7 Mon
Ehm {skeleton:'Ehm'}) Mon 12:43 AM
EHm {skeleton:'EHm;}); Mon 12:43
Ehms {skeleton:'Ehms' } Mon 2:45:23 PM
EHms {skeleton:'EHms'}) Mon 12:45:45
Gy {skeleton:'Gy' } 2016 AD
GyMMM {skeleton:'GyMMM'} : Nov 2016 AD
GyMMMd {skeleton:'GyMMMd'} Nov 7, 2016 AD
GyMMMEd {skeleton:'GyMMMEd'} Mon, Nov 7, 2016 AD
h {skeleton:'h'} 12 PM
H {skeleton:'H'} 12
hm {skeleton:'hm'} 12:59 PM
Hm {skeleton:'Hm'} 12:59
hms {skeleton:'hms'} 12:59:13 PM
Hms {skeleton:'Hms'} 12:59:13
M {skeleton:'M'} 11
Md {skeleton:'Md'} 11/7
MEd {skeleton:'hms'} Mon, 11/7
MMM {skeleton:'MMM'} Nov
MMMEd {skeleton:'MMMEd'} Mon, Nov 7
MMMd {skeleton:'MMMEd'} Nov 7
ms {skeleton:'ms'} 59:13
y {skeleton:'y' } 2016
yM {skeleton:'yM' } 11/2016
yMd {skeleton:'yMd' } 11/7/2016
yMEd {skeleton:'yMEd' } Mon, 11/7/2016
yMMM {skeleton:'yMMM' } Nov 2016
yMMMd {skeleton:'yMMMd'} Nov 7, 2016
yMMMEd {skeleton:'yMMMEd'} Mon, Nov 7, 2016
yMMM {skeleton:'yMMM'} Nov 2016

Note: Culture specific format skeletons are also supported.

Custom formats

To use the custom date and time formats, we need to specify the date/time pattern directly in the format property.
A custom format string must contain one or more of the following standard date/time symbols.

Symbols Description
G Denotes the era in the date
y Denotes the year.
M / L Denotes month.
E / c Denotes the day of week.
d Denotes the day of month.
h / H Denotes the hour. h for 12 hour and H for 24 hours format.
m Denotes minutes.
s Denotes seconds.
f Denotes milliseconds.
a Denotes the am/pm designator it will only be displayed if hour is specified in the h format.
z Denotes the time zone.
’ (single quotes) To display words in the formatted date you can specify the words with in the single quotes

Custom format example

import Vue from 'vue';
import { Internationalization } from '@syncfusion/ej2-base';
var intl  = new Internationalization();
var formattedString =  intl.formatDate(new Date('1/12/2014 10:20:33'), { format: '\'year:\'y' \'month:\' MM' });
//Output: "year:2014 month:01"

Note: If the format property is given as an option, other properties are not considered.

Date parsing

getDateParser

The getDateParser method returns a function that parses a string according to DateFormatOptions.

<template>
  <div class="result" ref="result"></div>
</template>
  
<script setup>
import { Internationalization } from '@syncfusion/ej2-base';
import { onMounted, ref } from 'vue';

const result = ref(null);
onMounted(() => {
  var intl = new Internationalization();
  var dParser = intl.getDateParser({ skeleton: 'full', type: 'dateTime' });
  var val = dParser('Friday, November 4, 2016 at 1:03:04 PM GMT+05:30');
  result.value.innerHTML = val.toString();
})
</script>
<template>
  <div class="result"> </div>
</template>
<script>
import { Internationalization } from '@syncfusion/ej2-base';
export default {
  mounted: function () {
    var intl = new Internationalization();
    var dParser = intl.getDateParser({ skeleton: 'full', type: 'dateTime' });
    var val = dParser('Friday, November 4, 2016 at 1:03:04 PM GMT+05:30');
    document.querySelector('.result').innerHTML = val.toString();
  }
}
</script>
<style></style>

parseDate

The parseDate method returns a Date object given a string and DateFormatOptions.

<template>
  <div class="result" ref="result"></div>
</template>
  
<script setup>
import { Internationalization } from '@syncfusion/ej2-base';
import { onMounted, ref } from 'vue';

const result = ref(null);

onMounted(() => {
  var intl = new Internationalization();
  var val = intl.parseDate('11/2016', { skeleton: 'yM' });
  result.value.innerHTML = val.toString();
})
</script>
<template>
  <div class="result"></div>
</template>
<script>
import Vue from 'vue';
import {Internationalization} from '@syncfusion/ej2-base';
export default {
  mounted:function(){
var intl = new Internationalization();
var val =  intl.parseDate('11/2016',{skeleton: 'yM'});
document.querySelector('.result').innerHTML = val.toString();
  }
}
</script>
<style>
</style>

Date Formatting

getDateFormat

The getDateFormat method, which will return a function that formats a given date object based on the DateFormatOptions specified.

<template>
  <div class="result" ref="result"></div>
</template>
  
<script setup>
import { Internationalization } from '@syncfusion/ej2-base';
import { onMounted, ref } from 'vue';

const result = ref(null);

onMounted(() => {
  var intl = new Internationalization();
  var dFormatter = intl.getDateFormat({ skeleton: 'full', type: 'dateTime' });
  var formattedString = dFormatter(new Date('1/12/2014 10:20:33'));
  result.value.innerHTML = formattedString;
});
</script>
<template>
  <div class="result"></div>
</template>
<script>
import { Internationalization } from '@syncfusion/ej2-base';
export default {
  mounted:function(){
var intl = new Internationalization();
var dFormatter = intl.getDateFormat({ skeleton: 'full', type: 'dateTime' });
var formattedString = dFormatter(new Date('1/12/2014 10:20:33'));
document.querySelector('.result').innerHTML = formattedString;
  }
}
</script>
<style>
</style>

formatDate

The formatDate method, which takes two arguments, the date object and DateFormatOptions, returns the formatted string.

<template>
  <div class="result" ref="result"></div>
</template>
  
<script setup>
import { Internationalization } from '@syncfusion/ej2-base';
import { onMounted, ref } from 'vue';

const result = ref(null);

onMounted(() => {
  var intl = new Internationalization();
  var formattedString = intl.formatDate(new Date('1/12/2014 10:20:33'), { skeleton: 'GyMMM' });
  result.value.innerHTML = formattedString;
})
</script>
<template>
  <div class="result"></div>
</template>
<script>
import { Internationalization } from '@syncfusion/ej2-base';
export default {
  mounted: function () {
    var intl = new Internationalization();
    var date = new Date();
    var formattedString = intl.formatDate(new Date('1/12/2014 10:20:33'), { skeleton: 'GyMMM' });
    document.querySelector('.result').innerHTML = formattedString;
  }
}
</script>
<style></style>

The Internationalization
library provides support for formatting and parsing date and number objects
using the official Unicode CLDR JSON data. The en-US
locale is
set as default culture and the USD
is set as default currencyCode for all Syncfusion React components.
It requires the following CLDR data to be load using loadCldr
function for cultures other than en-US
.
File Name | Path |
---|---|
ca-gregorian | cldr/main/en/ca-gregorian.json |
timeZoneNames | cldr/main/en/timeZoneNames.json |
numbers | cldr/main/en/numbers.json |
numberingSystems | cldr/supplemental/numberingSystems.json |
currencies | cldr/main/en/currencies.json |
Note: For en
, dependency files are already loaded in the library.
import { loadCldr } from '@syncfusion/ej2-base';
loadcldr(enNumberData, entimeZoneData);
To change the culture and the currencyCode for all Syncfusion React components, you can use the methods
setCulture
for setting default locale and setCurrencyCode
for setting the currencyCode.
import {setCulture, setCurrencyCode} from '@syncfusion/ej2-base';
setCulture('ar');
setCurrencyCode('QAR');
Note: If global culture is not set, then en-US
is set as default locale and the USD
is set as a default currency code.
Based on the NumberFormatOptions
number formatting and parsing operations are processed. You need to specify some or all of the following properties mentioned below table.
No | Properties | Description |
---|---|---|
1 | format |
Denotes the format to be set .Possible values are 1. N - denotes numeric type 2. C - denotes currency type 3. P – denotes percentage type. Ex: formatNumber ( 1234344 ,{format:’N4’}). > Note: If no format is specified it takes numeric as default format type. |
2 | minimumFractionDigits |
Indicates the minimum number of fraction digits . Possible values are 0 to 20. |
3 | maximumFractionDigits |
Indicates the maximum number of fraction digits. Possible values are 0 to 20. |
4 | minimumSignificantDigits |
Indicates he minimum number of significant digits. Possible values are 1 to 21. > Note: If minimumSignificantDigits is given it is mandatory to give maximumSignificantDigits |
5 | maximumSignificantDigits |
Indicates he maximum number of significant digits. . Possible values are 1 to 21. > Note: If maximumSignificantDigits is given it is mandatory to give minimumSignificantDigits |
6 | useGrouping |
Indicates whether to enable the group separator or not . By default grouping value will be true. |
7 | minimumIntegerDigits |
Indicates the minimum number of the integer digits to be placed in the value. Possible values are 1 to 21. |
8 | currency |
Indicates the currency code which needs to considered for the currency formatting. |
Note: The
minimumIntegerDigits
,minimumFractionDigits
andmaximumFractionDigits
are categorized as group one,minimumSignificantDigits
andmaximumSignificantDigits
are categorized as group two. If group two properties are defined, then the group one property will be ignored.
Custom number formatting and parsing is also supported by specifying the pattern directly
in the format property of NumberFormatOptions
. Custom number format can be achieved by
using one or more custom format specifiers listed in the below table.
Specifier | Description | Input | Format Output |
---|---|---|---|
0 | Replaces the zero with the corresponding digit if one is present. Otherwise, zero appears in the result string. | instance.formatNumber (123,{format: ‘0000’ }) |
‘0123’ |
# | Replaces the ”#” symbol with the corresponding digit if one is present; otherwise, no digit appears in the result string. | instance.formatNumber (1234,{format: ’####’ }) |
‘1234’ |
. | Denotes the number of digits allowed after the decimal points if it’s not specified then no need to specify decimal point values. | instance.formatNumber (546321,{format: ‘###0.##0#’ }) |
‘546321.000’ |
% | Percent specifier denotes the percentage type format. | instance.formatNumber (1,{format: ‘0000 %’ }) |
‘0100 %’ |
$ | Denotes the currency type format based on the global currency code specified. | instance.formatNumber (13,{format: ’$ ###.00’ }); |
‘$ 13.00’ |
; | Denotes separate formats for positive, negative and zero values. | instance.formatNumber (-120,{format: ’###.##;(###.00);-0’}); |
‘(120.00)’ |
‘String’ (single Quotes) | Denotes the characters enclosed within single Quote(’) to be replaced in the resultant string. | instance.formatNumber (-123.44,{format: ”####.## ’@’”}) |
‘123.44 @’ |
Note: If a custom format pattern is specified other NumberFormatOptions
properties will not be considered.
getNumberFormat
The getNumberFormat
method which will return a function that formats given numbers based on the
NumberFormatOptions
specified.
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { Internationalization } from '@syncfusion/ej2-base';
class App extends React.Component {
componentDidMount() {
let intl = new Internationalization();
let nFormatter = intl.getNumberFormat({ skeleton: 'C3', currency: 'USD', minimumIntegerDigits: 8 });
let formattedValue = nFormatter(1234545.65);
document.querySelector('.result').innerHTML = formattedValue;
}
render() {
return (<div id="container">
<div>Value:<span className="format text">1234545.65</span></div>
<div>Formatted Value:<span className="result text"/></div>
</div>);
}
}
ReactDom.render(<App />, document.getElementById('sample'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>Syncfusion React Button</title>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<meta name="description" content="Essential JS 2 for React Components" />
<meta name="author" content="Syncfusion" />
<link href="//cdn.syncfusion.com/ej2/20.1.57/ej2-react-buttons/styles/material.css" rel="stylesheet" />
<link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
<script src="systemjs.config.js"></script>
<style>
#loader {
color: #008cff;
height: 40px;
left: 45%;
position: absolute;
top: 45%;
width: 30%;
}
</style>
</head>
<body>
<div id='sample'>
<div id='loader'>Loading....</div>
</div>
</body>
</html>
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { Internationalization } from '@syncfusion/ej2-base';
class App extends React.Component<{}, {}> {
public componentDidMount(): void {
let intl: Internationalization = new Internationalization();
let nFormatter: Function = intl.getNumberFormat({ skeleton: 'C3', currency: 'USD', minimumIntegerDigits: 8 });
let formattedValue: string = nFormatter(1234545.65);
document.querySelector('.result').innerHTML = formattedValue;
}
render() {
return (
<div id="container">
<div>Value:<span className="format text">1234545.65</span></div>
<div>Formatted Value:<span className="result text" /></div>
</div>
);
}
}
ReactDom.render(<App />, document.getElementById('sample'));
formatNumber
The formatNumber
method which takes two arguments numeric value andNumberFormatOptions
and returns the formatted string.
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { Internationalization } from '@syncfusion/ej2-base';
class App extends React.Component {
componentDidMount() {
let intl = new Internationalization();
let formattedString = intl.formatNumber(12345.65, {
format: 'C5', useGrouping: false,
minimumSignificantDigits: 1, maximumSignificantDigits: 3
});
document.querySelector('.result').innerHTML = formattedString;
}
render() {
return (<div id="container">
<div>Value:<span className="format text">12345.65</span></div>
<div>Formatted Value:<span className="result text"/></div>
</div>);
}
}
ReactDom.render(<App />, document.getElementById('sample'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>Syncfusion React Button</title>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<meta name="description" content="Essential JS 2 for React Components" />
<meta name="author" content="Syncfusion" />
<link href="//cdn.syncfusion.com/ej2/20.1.57/ej2-react-buttons/styles/material.css" rel="stylesheet" />
<link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
<script src="systemjs.config.js"></script>
<style>
#loader {
color: #008cff;
height: 40px;
left: 45%;
position: absolute;
top: 45%;
width: 30%;
}
</style>
</head>
<body>
<div id='sample'>
<div id='loader'>Loading....</div>
</div>
</body>
</html>
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { Internationalization } from '@syncfusion/ej2-base';
class App extends React.Component<{}, {}> {
public componentDidMount(): void {
let intl: Internationalization = new Internationalization();
let formattedString: string = intl.formatNumber(12345.65, {
format: 'C5', useGrouping: false,
minimumSignificantDigits: 1, maximumSignificantDigits: 3
});
document.querySelector('.result').innerHTML = formattedString;
}
render() {
return (
<div id="container">
<div>Value:<span className="format text">12345.65</span></div>
<div>Formatted Value:<span className="result text" /></div>
</div>
);
}
}
ReactDom.render(<App />, document.getElementById('sample'));
getNumberParser
The getNumberParser
method which will return a function
that parses given string based on the NumberFormatOptions
specified.
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { Internationalization } from '@syncfusion/ej2-base';
class App extends React.Component {
componentDidMount() {
let intl = new Internationalization();
let nParser = intl.getNumberParser({ format: 'P2', useGrouping: false });
let val = nParser('123567.45%');
document.querySelector('.result').innerHTML = val + '';
}
render() {
return (<div id="container">
<div>FormattedValue:<span className="format text">123567.45%</span></div>
<div>ParsedOutput:<span className="result text"/></div>
</div>);
}
}
ReactDom.render(<App />, document.getElementById('sample'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>Syncfusion React Button</title>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<meta name="description" content="Essential JS 2 for React Components" />
<meta name="author" content="Syncfusion" />
<link href="//cdn.syncfusion.com/ej2/20.1.57/ej2-react-buttons/styles/material.css" rel="stylesheet" />
<link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
<script src="systemjs.config.js"></script>
<style>
#loader {
color: #008cff;
height: 40px;
left: 45%;
position: absolute;
top: 45%;
width: 30%;
}
</style>
</head>
<body>
<div id='sample'>
<div id='loader'>Loading....</div>
</div>
</body>
</html>
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { Internationalization } from '@syncfusion/ej2-base';
class App extends React.Component<{}, {}> {
public componentDidMount(): void {
let intl: Internationalization = new Internationalization();
let nParser: Function = intl.getNumberParser({ format:'P2' , useGrouping: false});
let val: number = nParser('123567.45%');
document.querySelector('.result').innerHTML = val + '';
}
render() {
return (
<div id="container">
<div>FormattedValue:<span className="format text">123567.45%</span></div>
<div>ParsedOutput:<span className="result text"/></div>
</div>
);
}
}
ReactDom.render(<App />, document.getElementById('sample'));
parseNumber
The parseNumber
method which takes two arguments the string value and NumberFormatOptions
and returns the numeric value.
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { Internationalization } from '@syncfusion/ej2-base';
class App extends React.Component {
componentDidMount() {
let intl = new Internationalization();
let val = intl.parseNumber('1. ,234,545.650', { format: 'C3', currency: 'USD', minimumIntegerDigits: 8 });
document.querySelector('.result').innerHTML = val + '';
}
render() {
return (<div id="container">
<div>FormattedValue:<span className="format text">1. ,234,545.650</span></div>
<div>ParsedOutput:<span className="result text"/></div>
</div>);
}
}
ReactDom.render(<App />, document.getElementById('sample'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>Syncfusion React Button</title>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<meta name="description" content="Essential JS 2 for React Components" />
<meta name="author" content="Syncfusion" />
<link href="//cdn.syncfusion.com/ej2/20.1.57/ej2-react-buttons/styles/material.css" rel="stylesheet" />
<link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
<script src="systemjs.config.js"></script>
<style>
#loader {
color: #008cff;
height: 40px;
left: 45%;
position: absolute;
top: 45%;
width: 30%;
}
</style>
</head>
<body>
<div id='sample'>
<div id='loader'>Loading....</div>
</div>
</body>
</html>
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { Internationalization } from '@syncfusion/ej2-base';
class App extends React.Component<{}, {}> {
public componentDidMount(): void {
let intl: Internationalization = new Internationalization();
let val: number = intl.parseNumber('1. ,234,545.650', { format: 'C3', currency: 'USD', minimumIntegerDigits: 8 });
document.querySelector('.result').innerHTML = val + '';
}
render() {
return (
<div id="container">
<div>FormattedValue:<span className="format text">1. ,234,545.650</span></div>
<div>ParsedOutput:<span className="result text" /></div>
</div>
);
}
}
ReactDom.render(<App />, document.getElementById('sample'));
Based on the DateFormatOptions
date formatting and parsing operations are processed. You need to specify some or all of the following properties
mentioned below table.
Options | Descriptions | |
---|---|---|
Type | It specifies the type of format to be used supported types . 1. date 2. dateTime 3. time Based on the type specified the supported skeletons are given below 1. short 2. medium, 3. long 4. full Ex: formatDate (new Date(), {type: ’date’, skeleton:medium})> Note: If not type specified then date type is set by default |
|
skeleton | Specifies the format in which the dateTime format will process |
Date type skeletons
skeleton | Option input | Format Output |
---|---|---|
short | {type: ’date’, skeleton:’short’}) | 11/4/16 |
medium | {type: ’date’, skeleton:’medium’}) | Nov 4, 2016 |
long | {type: ’date’, skeleton:’long’} | November 4, 2016 |
full | {type: ’date’, skeleton:full}) | Friday, November 4, 2016 |
Time type skeletons
skeleton | Option input | Format Output |
---|---|---|
short | {type: ’time’, skeleton:’short’} | 1:03 PM |
medium | {type: ’time’, skeleton:’medium’} | 1:03:04 PM |
Long | {type: ’time’, skeleton:’long’}) | 1:03:04 PM GMT+5 |
full | {type: ’time’, skeleton:’full’}) | 1:03:04 PM GMT+05:30 |
DateTime type skeletons
Skeleton | Option input | Format Output |
---|---|---|
short | {type: ’dateTime ’, skeleton:’short’} |
11/4/16, 1:03 PM |
medium | {type: ’dateTime , skeleton:’medium’} |
Nov 4, 2016, 1:03:04 PM |
Long | {type: ’dateTime ’, skeleton:’long’}) |
November 4, 2016 at 1:03:04 PM GMT+5 |
full | {type: ’dateTime ’, skeleton:’full’}) |
Friday, November 4, 2016 at 1:03:04 PM GMT+05:30 |
Additional skeletons
Apart from the standard date type formats additional format is supported by using the additional skeletons given in below table.
skeleton | Option input | Format Output |
---|---|---|
d | {skeleton:’d’} | 7 |
E | {skeleton:’E’} | Mon |
Ed | {skeleton:’Ed’} | 7 Mon |
Ehm | {skeleton:’Ehm’}) | Mon 12:43 AM |
EHm | {skeleton:’EHm;}); | Mon 12:43 |
Ehms | {skeleton:’Ehms’ } | Mon 2:45:23 PM |
EHms | {skeleton:’EHms’}) | Mon 12:45:45 |
Gy | {skeleton:’Gy’ } | 2016 AD |
GyMMM | {skeleton:’GyMMM’} | : Nov 2016 AD |
GyMMMd | {skeleton:’GyMMMd’} | Nov 7, 2016 AD |
GyMMMEd | {skeleton:’GyMMMEd’} | Mon, Nov 7, 2016 AD |
h | {skeleton:’h’} | 12 PM |
H | {skeleton:’H’} | 12 |
hm | {skeleton:’hm’} | 12:59 PM |
Hm | {skeleton:’Hm’} | 12:59 |
hms | {skeleton:’hms’} | 12:59:13 PM |
Hms | {skeleton:’Hms’} | 12:59:13 |
M | {skeleton:’M’} | 11 |
Md | {skeleton:’Md’} | 11/7 |
MEd | {skeleton:’hms’} | Mon, 11/7 |
MMM | {skeleton:’MMM’} | Nov |
MMMEd | {skeleton:’MMMEd’} | Mon, Nov 7 |
MMMd | {skeleton:’MMMEd’} | Nov 7 |
ms | {skeleton:’ms’} | 59:13 |
y | {skeleton:’y’ } | 2016 |
yM | {skeleton:’yM’ } | 11/2016 |
yMd | {skeleton:’yMd’ } | 11/7/2016 |
yMEd | {skeleton:’yMEd’ } | Mon, 11/7/2016 |
yMMM | {skeleton:’yMMM’ } | Nov 2016 |
yMMMd | {skeleton:’yMMMd’} | Nov 7, 2016 |
yMMMEd | {skeleton:’yMMMEd’} | Mon, Nov 7, 2016 |
yMMM | {skeleton:’yMMM’} | Nov 2016 |
Note: Culture specific format skeletons are also supported.
To use the custom date and time formats we need to specify the date/time pattern directly in the format property. The custom format string must contain one or more of the following standard date/time symbols
Symbols | Description |
---|---|
G | Denotes the era in the date |
y | Denotes the year. |
M / L | Denotes month. |
E / c | Denotes the day of week. |
d | Denotes the day of month. |
h / H | Denotes the hour. h for 12 hour and H for 24 hours format. |
m | Denotes minutes. |
s | Denotes seconds. |
a | Denotes the am/pm designator it will only be displayed if hour is specified in the h format. |
z | Denotes the time zone. |
’ (single quotes) | To display words in the formatted date you can specify the words with in the single quotes |
Custom format example
import { Internationalization } from '@syncfusion/ej2-base';
let intl: Internationalization = new Internationalization();
let formattedString: string = intl.formatDate(new Date('1/12/2014 10:20:33'), { format: '\'year:\'y' \'month:\' MM' });
//Output: "year:2014 month:01"
Note: If format property is given in options other properties are not considered.
getDateFormat
The getDateFormat
method which will return a function that formats given date object based on the
DateFormatOptions
specified.
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { Internationalization } from '@syncfusion/ej2-base';
class App extends React.Component {
componentDidMount() {
let intl = new Internationalization();
let dFormatter = intl.getDateFormat({ skeleton: 'full', type: 'dateTime' });
let formattedString = dFormatter(new Date('1/12/2014 10:20:33'));
document.querySelector('.result').innerHTML = formattedString;
}
render() {
return (<div id="container">
<div>DateValue:<span className="format text">new Date('1/12/2014 10:20:33')</span></div>
<div>Formatted Value:<span className="result text"/></div>
</div>);
}
}
ReactDom.render(<App />, document.getElementById('sample'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>Syncfusion React Button</title>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<meta name="description" content="Essential JS 2 for React Components" />
<meta name="author" content="Syncfusion" />
<link href="//cdn.syncfusion.com/ej2/20.1.57/ej2-react-buttons/styles/material.css" rel="stylesheet" />
<link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
<script src="systemjs.config.js"></script>
<style>
#loader {
color: #008cff;
height: 40px;
left: 45%;
position: absolute;
top: 45%;
width: 30%;
}
</style>
</head>
<body>
<div id='sample'>
<div id='loader'>Loading....</div>
</div>
</body>
</html>
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { Internationalization } from '@syncfusion/ej2-base';
class App extends React.Component<{}, {}> {
public componentDidMount(): void {
let intl: Internationalization = new Internationalization();
let dFormatter: Function = intl.getDateFormat({ skeleton: 'full', type: 'dateTime' });
let formattedString: string = dFormatter(new Date('1/12/2014 10:20:33'));
document.querySelector('.result').innerHTML = formattedString;
}
render() {
return (
<div id="container">
<div>DateValue:<span className="format text">new Date('1/12/2014 10:20:33')</span></div>
<div>Formatted Value:<span className="result text" /></div>
</div>
);
}
}
ReactDom.render(<App />, document.getElementById('sample'));
formatDate
The formatDate
method which takes two arguments date object and
DateFormatOptions
and
returns the formatted string.
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { Internationalization } from '@syncfusion/ej2-base';
class App extends React.Component {
componentDidMount() {
let intl = new Internationalization();
let formattedString = intl.formatDate(new Date('1/12/2014 10:20:33'), { skeleton: 'GyMMM' });
document.querySelector('.result').innerHTML = formattedString;
}
render() {
return (<div id="container">
<div>DateValue:<span className="format text">new Date('1/12/2014 10:20:33')</span></div>
<div>Formatted Value:<span className="result text"/></div>
</div>);
}
}
ReactDom.render(<App />, document.getElementById('sample'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>Syncfusion React Button</title>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<meta name="description" content="Essential JS 2 for React Components" />
<meta name="author" content="Syncfusion" />
<link href="//cdn.syncfusion.com/ej2/20.1.57/ej2-react-buttons/styles/material.css" rel="stylesheet" />
<link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
<script src="systemjs.config.js"></script>
<style>
#loader {
color: #008cff;
height: 40px;
left: 45%;
position: absolute;
top: 45%;
width: 30%;
}
</style>
</head>
<body>
<div id='sample'>
<div id='loader'>Loading....</div>
</div>
</body>
</html>
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { Internationalization } from '@syncfusion/ej2-base';
class App extends React.Component<{}, {}> {
public componentDidMount(): void {
let intl: Internationalization = new Internationalization();
let formattedString: string = intl.formatDate(new Date('1/12/2014 10:20:33'), { skeleton: 'GyMMM' });
document.querySelector('.result').innerHTML = formattedString;
}
render() {
return (
<div id="container">
<div>DateValue:<span className="format text">new Date('1/12/2014 10:20:33')</span></div>
<div>Formatted Value:<span className="result text" /></div>
</div>
);
}
}
ReactDom.render(<App />, document.getElementById('sample'));
getDateParser
The getDateParser
method which will return a function that parses given string based on the
DateFormatOptions
specified.
import { Internationalization } from '@syncfusion/ej2-base';
import * as React from 'react';
import * as ReactDom from 'react-dom';
class App extends React.Component {
componentDidMount() {
let intl = new Internationalization();
let dParser = intl.getDateParser({ skeleton: 'full', type: 'dateTime' });
let val = dParser('Friday, November 4, 2016 at 1:03:04 PM GMT+05:30');
document.querySelector('.result').innerHTML = val.toString();
}
render() {
return (<div id="container">
<div>Fromatted value:<span className="format text">Friday, November 4, 2016 at 1:03:04 PM GMT+05:30</span></div>
<div>parsed Value:<span className="result text"/></div>
</div>);
}
}
ReactDom.render(<App />, document.getElementById('sample'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>Syncfusion React Button</title>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<meta name="description" content="Essential JS 2 for React Components" />
<meta name="author" content="Syncfusion" />
<link href="//cdn.syncfusion.com/ej2/20.1.57/ej2-react-buttons/styles/material.css" rel="stylesheet" />
<link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
<script src="systemjs.config.js"></script>
<style>
#loader {
color: #008cff;
height: 40px;
left: 45%;
position: absolute;
top: 45%;
width: 30%;
}
</style>
</head>
<body>
<div id='sample'>
<div id='loader'>Loading....</div>
</div>
</body>
</html>
import { Internationalization } from '@syncfusion/ej2-base';
import * as React from 'react';
import * as ReactDom from 'react-dom';
class App extends React.Component<{}, {}> {
public componentDidMount(): void {
let intl: Internationalization = new Internationalization();
let dParser: Function = intl.getDateParser({ skeleton: 'full', type: 'dateTime' });
let val: Date = dParser('Friday, November 4, 2016 at 1:03:04 PM GMT+05:30');
document.querySelector('.result').innerHTML = val.toString();
}
render() {
return (
<div id="container">
<div>Fromatted value:<span className="format text">Friday, November 4, 2016 at 1:03:04 PM GMT+05:30</span></div>
<div>parsed Value:<span className="result text" /></div>
</div>
);
}
}
ReactDom.render(<App />, document.getElementById('sample'));
parseDate
The parseDate
method which takes two argument’s string value and DateFormatOptions
and returns the date Object.
import { Internationalization } from '@syncfusion/ej2-base';
import * as React from 'react';
import * as ReactDom from 'react-dom';
class App extends React.Component {
componentDidMount() {
let intl = new Internationalization();
let val = intl.parseDate('11/2016', { skeleton: 'yM' });
document.querySelector('.result').innerHTML = val.toString();
}
render() {
return (<div id="container">
<div>Fromatted value:<span className="format text">11/2016</span></div>
<div>parsed Value:<span className="result text"/></div>
</div>);
}
}
ReactDom.render(<App />, document.getElementById('sample'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>Syncfusion React Button</title>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<meta name="description" content="Essential JS 2 for React Components" />
<meta name="author" content="Syncfusion" />
<link href="//cdn.syncfusion.com/ej2/20.1.57/ej2-react-buttons/styles/material.css" rel="stylesheet" />
<link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
<script src="systemjs.config.js"></script>
<style>
#loader {
color: #008cff;
height: 40px;
left: 45%;
position: absolute;
top: 45%;
width: 30%;
}
</style>
</head>
<body>
<div id='sample'>
<div id='loader'>Loading....</div>
</div>
</body>
</html>
import { Internationalization } from '@syncfusion/ej2-base';
import * as React from 'react';
import * as ReactDom from 'react-dom';
class App extends React.Component<{}, {}> {
public componentDidMount(): void {
let intl: Internationalization = new Internationalization();
let val: Date = intl.parseDate('11/2016', { skeleton: 'yM' });
document.querySelector('.result').innerHTML = val.toString();
}
render() {
return (
<div id="container">
<div>Fromatted value:<span className="format text">11/2016</span></div>
<div>parsed Value:<span className="result text" /></div>
</div>
);
}
}
ReactDom.render(<App />, document.getElementById('sample'));